// ++++++++++++++++++++++++++++++++++
// + Code generated by dcc 1.0      +
// ++++++++++++++++++++++++++++++++++

static int cs[1000];
static int cs_c=0;
static double fds[1000];
static int fds_c=0;
//static int ids[1000];
//static int ids_c=0;
//void rhs(double* f, double* x, double* p, int &n, int &m)
////$ad indep p x
////$ad dep f
//{
//   f[0] = 0-p[2]*x[1]*x[7];
//   f[1] = 0-p[0]*x[1]*x[5]+p[1]*x[9]-p[2]*x[1]*x[7];
//   f[2] =p[2]*x[1]*x[7]+p[3]*x[3]*x[5]-p[4]*x[8];
//   f[3] =0-p[3]*x[3]*x[5]+p[4]*x[8];
//   f[4] =p[0]*x[1]*x[5]-p[1]*x[9];
//   f[5] =0-p[0]*x[1]*x[5]-p[3]*x[3]*x[5]+p[1]*x[9]+p[4]*x[8];
//   f[6] =0-0.0131+x[5]+x[7]+x[8]+x[9]-x[6];
//   f[7] =p[6]*x[0]/(p[6]+x[6])-x[7];
//   f[8] =p[7]*x[2]/(p[7]+x[6])-x[8];
//   f[9] =p[5]*x[4]/(p[5]+x[6])-x[9];
//}
void b1_rhs(int& bmode_1, double* f, double* b1_f, double* x, double* b1_x, double* p, double* b1_p, int& n, int& m)
//$ad indep p b1_p x b1_x b1_f
//$ad dep f b1_p b1_x
{
   double v1_0=0;
   double b1_v1_0=0;
   double v1_1=0;
   double b1_v1_1=0;
   double v1_2=0;
   double b1_v1_2=0;
   double v1_3=0;
   double b1_v1_3=0;
   double v1_4=0;
   double b1_v1_4=0;
   double v1_5=0;
   double b1_v1_5=0;
   double v1_6=0;
   double b1_v1_6=0;
   double v1_7=0;
   double b1_v1_7=0;
   double v1_8=0;
   double b1_v1_8=0;
   double v1_9=0;
   double b1_v1_9=0;
   double v1_10=0;
   double b1_v1_10=0;
   double v1_11=0;
   double b1_v1_11=0;
   double v1_12=0;
   double b1_v1_12=0;
   double v1_13=0;
   double b1_v1_13=0;
   double v1_14=0;
   double b1_v1_14=0;
   double v1_15=0;
   double b1_v1_15=0;
   double v1_16=0;
   double b1_v1_16=0;
   double v1_17=0;
   double b1_v1_17=0;
   double v1_18=0;
   double b1_v1_18=0;
   double v1_19=0;
   double b1_v1_19=0;
   double v1_20=0;
   double b1_v1_20=0;
   int save_cs_c=0;
   save_cs_c=cs_c;
   if (bmode_1==1) {
      // augmented forward section
      // new basic block 
      cs[cs_c]=0; cs_c=cs_c+1;
      // augmented assignment 
      fds[fds_c]=f[0]; fds_c=fds_c+1; f[0]=0-p[2]*x[1]*x[7];
      // augmented assignment 
      fds[fds_c]=f[1]; fds_c=fds_c+1; f[1]=0-p[0]*x[1]*x[5]+p[1]*x[9]-p[2]*x[1]*x[7];
      // augmented assignment 
      fds[fds_c]=f[2]; fds_c=fds_c+1; f[2]=p[2]*x[1]*x[7]+p[3]*x[3]*x[5]-p[4]*x[8];
      // augmented assignment 
      fds[fds_c]=f[3]; fds_c=fds_c+1; f[3]=0-p[3]*x[3]*x[5]+p[4]*x[8];
      // augmented assignment 
      fds[fds_c]=f[4]; fds_c=fds_c+1; f[4]=p[0]*x[1]*x[5]-p[1]*x[9];
      // augmented assignment 
      fds[fds_c]=f[5]; fds_c=fds_c+1; f[5]=0-p[0]*x[1]*x[5]-p[3]*x[3]*x[5]+p[1]*x[9]+p[4]*x[8];
      // augmented assignment 
      fds[fds_c]=f[6]; fds_c=fds_c+1; f[6]=0-0.0131+x[5]+x[7]+x[8]+x[9]-x[6];
      // augmented assignment 
      fds[fds_c]=f[7]; fds_c=fds_c+1; f[7]=p[6]*x[0]/(p[6]+x[6])-x[7];
      // augmented assignment 
      fds[fds_c]=f[8]; fds_c=fds_c+1; f[8]=p[7]*x[2]/(p[7]+x[6])-x[8];
      // augmented assignment 
      fds[fds_c]=f[9]; fds_c=fds_c+1; f[9]=p[5]*x[4]/(p[5]+x[6])-x[9];
      // reverse section
      while (cs_c>save_cs_c) {
        cs_c=cs_c-1;
        if (cs[cs_c]==0) {
          // incomplete SAC
          fds_c=fds_c-1; f[9]=fds[fds_c];
          v1_0=p[5];
          v1_1=x[4];
          v1_2=v1_0*v1_1;
          v1_3=p[5];
          v1_4=x[6];
          v1_5=v1_3+v1_4;
          v1_6=v1_5;
          v1_7=v1_2/v1_6;
          v1_8=x[9];
          v1_9=v1_7-v1_8;
          // adjoint assignment
          b1_v1_9=b1_f[9]; b1_f[9]=0;
          b1_v1_7=b1_v1_9; b1_v1_8=0-b1_v1_9;
          b1_x[9]=b1_x[9]+b1_v1_8;
          b1_v1_2=1/v1_6*b1_v1_7; b1_v1_6=0-v1_2/(v1_6*v1_6)*b1_v1_7;
          b1_v1_5=b1_v1_6;
          b1_v1_3=b1_v1_5; b1_v1_4=b1_v1_5;
          b1_x[6]=b1_x[6]+b1_v1_4;
          b1_p[5]=b1_p[5]+b1_v1_3;
          b1_v1_0=v1_1*b1_v1_2; b1_v1_1=v1_0*b1_v1_2;
          b1_x[4]=b1_x[4]+b1_v1_1;
          b1_p[5]=b1_p[5]+b1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[8]=fds[fds_c];
          v1_0=p[7];
          v1_1=x[2];
          v1_2=v1_0*v1_1;
          v1_3=p[7];
          v1_4=x[6];
          v1_5=v1_3+v1_4;
          v1_6=v1_5;
          v1_7=v1_2/v1_6;
          v1_8=x[8];
          v1_9=v1_7-v1_8;
          // adjoint assignment
          b1_v1_9=b1_f[8]; b1_f[8]=0;
          b1_v1_7=b1_v1_9; b1_v1_8=0-b1_v1_9;
          b1_x[8]=b1_x[8]+b1_v1_8;
          b1_v1_2=1/v1_6*b1_v1_7; b1_v1_6=0-v1_2/(v1_6*v1_6)*b1_v1_7;
          b1_v1_5=b1_v1_6;
          b1_v1_3=b1_v1_5; b1_v1_4=b1_v1_5;
          b1_x[6]=b1_x[6]+b1_v1_4;
          b1_p[7]=b1_p[7]+b1_v1_3;
          b1_v1_0=v1_1*b1_v1_2; b1_v1_1=v1_0*b1_v1_2;
          b1_x[2]=b1_x[2]+b1_v1_1;
          b1_p[7]=b1_p[7]+b1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[7]=fds[fds_c];
          v1_0=p[6];
          v1_1=x[0];
          v1_2=v1_0*v1_1;
          v1_3=p[6];
          v1_4=x[6];
          v1_5=v1_3+v1_4;
          v1_6=v1_5;
          v1_7=v1_2/v1_6;
          v1_8=x[7];
          v1_9=v1_7-v1_8;
          // adjoint assignment
          b1_v1_9=b1_f[7]; b1_f[7]=0;
          b1_v1_7=b1_v1_9; b1_v1_8=0-b1_v1_9;
          b1_x[7]=b1_x[7]+b1_v1_8;
          b1_v1_2=1/v1_6*b1_v1_7; b1_v1_6=0-v1_2/(v1_6*v1_6)*b1_v1_7;
          b1_v1_5=b1_v1_6;
          b1_v1_3=b1_v1_5; b1_v1_4=b1_v1_5;
          b1_x[6]=b1_x[6]+b1_v1_4;
          b1_p[6]=b1_p[6]+b1_v1_3;
          b1_v1_0=v1_1*b1_v1_2; b1_v1_1=v1_0*b1_v1_2;
          b1_x[0]=b1_x[0]+b1_v1_1;
          b1_p[6]=b1_p[6]+b1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[6]=fds[fds_c];
          v1_0=0;
          v1_1=0.0131;
          v1_2=v1_0-v1_1;
          v1_3=x[5];
          v1_4=v1_2+v1_3;
          v1_5=x[7];
          v1_6=v1_4+v1_5;
          v1_7=x[8];
          v1_8=v1_6+v1_7;
          v1_9=x[9];
          v1_10=v1_8+v1_9;
          v1_11=x[6];
          v1_12=v1_10-v1_11;
          // adjoint assignment
          b1_v1_12=b1_f[6]; b1_f[6]=0;
          b1_v1_10=b1_v1_12; b1_v1_11=0-b1_v1_12;
          b1_x[6]=b1_x[6]+b1_v1_11;
          b1_v1_8=b1_v1_10; b1_v1_9=b1_v1_10;
          b1_x[9]=b1_x[9]+b1_v1_9;
          b1_v1_6=b1_v1_8; b1_v1_7=b1_v1_8;
          b1_x[8]=b1_x[8]+b1_v1_7;
          b1_v1_4=b1_v1_6; b1_v1_5=b1_v1_6;
          b1_x[7]=b1_x[7]+b1_v1_5;
          b1_v1_2=b1_v1_4; b1_v1_3=b1_v1_4;
          b1_x[5]=b1_x[5]+b1_v1_3;
          b1_v1_0=b1_v1_2; b1_v1_1=0-b1_v1_2;
          // incomplete SAC
          fds_c=fds_c-1; f[5]=fds[fds_c];
          v1_0=0;
          v1_1=p[0];
          v1_2=x[1];
          v1_3=v1_1*v1_2;
          v1_4=x[5];
          v1_5=v1_3*v1_4;
          v1_6=v1_0-v1_5;
          v1_7=p[3];
          v1_8=x[3];
          v1_9=v1_7*v1_8;
          v1_10=x[5];
          v1_11=v1_9*v1_10;
          v1_12=v1_6-v1_11;
          v1_13=p[1];
          v1_14=x[9];
          v1_15=v1_13*v1_14;
          v1_16=v1_12+v1_15;
          v1_17=p[4];
          v1_18=x[8];
          v1_19=v1_17*v1_18;
          v1_20=v1_16+v1_19;
          // adjoint assignment
          b1_v1_20=b1_f[5]; b1_f[5]=0;
          b1_v1_16=b1_v1_20; b1_v1_19=b1_v1_20;
          b1_v1_17=v1_18*b1_v1_19; b1_v1_18=v1_17*b1_v1_19;
          b1_x[8]=b1_x[8]+b1_v1_18;
          b1_p[4]=b1_p[4]+b1_v1_17;
          b1_v1_12=b1_v1_16; b1_v1_15=b1_v1_16;
          b1_v1_13=v1_14*b1_v1_15; b1_v1_14=v1_13*b1_v1_15;
          b1_x[9]=b1_x[9]+b1_v1_14;
          b1_p[1]=b1_p[1]+b1_v1_13;
          b1_v1_6=b1_v1_12; b1_v1_11=0-b1_v1_12;
          b1_v1_9=v1_10*b1_v1_11; b1_v1_10=v1_9*b1_v1_11;
          b1_x[5]=b1_x[5]+b1_v1_10;
          b1_v1_7=v1_8*b1_v1_9; b1_v1_8=v1_7*b1_v1_9;
          b1_x[3]=b1_x[3]+b1_v1_8;
          b1_p[3]=b1_p[3]+b1_v1_7;
          b1_v1_0=b1_v1_6; b1_v1_5=0-b1_v1_6;
          b1_v1_3=v1_4*b1_v1_5; b1_v1_4=v1_3*b1_v1_5;
          b1_x[5]=b1_x[5]+b1_v1_4;
          b1_v1_1=v1_2*b1_v1_3; b1_v1_2=v1_1*b1_v1_3;
          b1_x[1]=b1_x[1]+b1_v1_2;
          b1_p[0]=b1_p[0]+b1_v1_1;
          // incomplete SAC
          fds_c=fds_c-1; f[4]=fds[fds_c];
          v1_0=p[0];
          v1_1=x[1];
          v1_2=v1_0*v1_1;
          v1_3=x[5];
          v1_4=v1_2*v1_3;
          v1_5=p[1];
          v1_6=x[9];
          v1_7=v1_5*v1_6;
          v1_8=v1_4-v1_7;
          // adjoint assignment
          b1_v1_8=b1_f[4]; b1_f[4]=0;
          b1_v1_4=b1_v1_8; b1_v1_7=0-b1_v1_8;
          b1_v1_5=v1_6*b1_v1_7; b1_v1_6=v1_5*b1_v1_7;
          b1_x[9]=b1_x[9]+b1_v1_6;
          b1_p[1]=b1_p[1]+b1_v1_5;
          b1_v1_2=v1_3*b1_v1_4; b1_v1_3=v1_2*b1_v1_4;
          b1_x[5]=b1_x[5]+b1_v1_3;
          b1_v1_0=v1_1*b1_v1_2; b1_v1_1=v1_0*b1_v1_2;
          b1_x[1]=b1_x[1]+b1_v1_1;
          b1_p[0]=b1_p[0]+b1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[3]=fds[fds_c];
          v1_0=0;
          v1_1=p[3];
          v1_2=x[3];
          v1_3=v1_1*v1_2;
          v1_4=x[5];
          v1_5=v1_3*v1_4;
          v1_6=v1_0-v1_5;
          v1_7=p[4];
          v1_8=x[8];
          v1_9=v1_7*v1_8;
          v1_10=v1_6+v1_9;
          // adjoint assignment
          b1_v1_10=b1_f[3]; b1_f[3]=0;
          b1_v1_6=b1_v1_10; b1_v1_9=b1_v1_10;
          b1_v1_7=v1_8*b1_v1_9; b1_v1_8=v1_7*b1_v1_9;
          b1_x[8]=b1_x[8]+b1_v1_8;
          b1_p[4]=b1_p[4]+b1_v1_7;
          b1_v1_0=b1_v1_6; b1_v1_5=0-b1_v1_6;
          b1_v1_3=v1_4*b1_v1_5; b1_v1_4=v1_3*b1_v1_5;
          b1_x[5]=b1_x[5]+b1_v1_4;
          b1_v1_1=v1_2*b1_v1_3; b1_v1_2=v1_1*b1_v1_3;
          b1_x[3]=b1_x[3]+b1_v1_2;
          b1_p[3]=b1_p[3]+b1_v1_1;
          // incomplete SAC
          fds_c=fds_c-1; f[2]=fds[fds_c];
          v1_0=p[2];
          v1_1=x[1];
          v1_2=v1_0*v1_1;
          v1_3=x[7];
          v1_4=v1_2*v1_3;
          v1_5=p[3];
          v1_6=x[3];
          v1_7=v1_5*v1_6;
          v1_8=x[5];
          v1_9=v1_7*v1_8;
          v1_10=v1_4+v1_9;
          v1_11=p[4];
          v1_12=x[8];
          v1_13=v1_11*v1_12;
          v1_14=v1_10-v1_13;
          // adjoint assignment
          b1_v1_14=b1_f[2]; b1_f[2]=0;
          b1_v1_10=b1_v1_14; b1_v1_13=0-b1_v1_14;
          b1_v1_11=v1_12*b1_v1_13; b1_v1_12=v1_11*b1_v1_13;
          b1_x[8]=b1_x[8]+b1_v1_12;
          b1_p[4]=b1_p[4]+b1_v1_11;
          b1_v1_4=b1_v1_10; b1_v1_9=b1_v1_10;
          b1_v1_7=v1_8*b1_v1_9; b1_v1_8=v1_7*b1_v1_9;
          b1_x[5]=b1_x[5]+b1_v1_8;
          b1_v1_5=v1_6*b1_v1_7; b1_v1_6=v1_5*b1_v1_7;
          b1_x[3]=b1_x[3]+b1_v1_6;
          b1_p[3]=b1_p[3]+b1_v1_5;
          b1_v1_2=v1_3*b1_v1_4; b1_v1_3=v1_2*b1_v1_4;
          b1_x[7]=b1_x[7]+b1_v1_3;
          b1_v1_0=v1_1*b1_v1_2; b1_v1_1=v1_0*b1_v1_2;
          b1_x[1]=b1_x[1]+b1_v1_1;
          b1_p[2]=b1_p[2]+b1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[1]=fds[fds_c];
          v1_0=0;
          v1_1=p[0];
          v1_2=x[1];
          v1_3=v1_1*v1_2;
          v1_4=x[5];
          v1_5=v1_3*v1_4;
          v1_6=v1_0-v1_5;
          v1_7=p[1];
          v1_8=x[9];
          v1_9=v1_7*v1_8;
          v1_10=v1_6+v1_9;
          v1_11=p[2];
          v1_12=x[1];
          v1_13=v1_11*v1_12;
          v1_14=x[7];
          v1_15=v1_13*v1_14;
          v1_16=v1_10-v1_15;
          // adjoint assignment
          b1_v1_16=b1_f[1]; b1_f[1]=0;
          b1_v1_10=b1_v1_16; b1_v1_15=0-b1_v1_16;
          b1_v1_13=v1_14*b1_v1_15; b1_v1_14=v1_13*b1_v1_15;
          b1_x[7]=b1_x[7]+b1_v1_14;
          b1_v1_11=v1_12*b1_v1_13; b1_v1_12=v1_11*b1_v1_13;
          b1_x[1]=b1_x[1]+b1_v1_12;
          b1_p[2]=b1_p[2]+b1_v1_11;
          b1_v1_6=b1_v1_10; b1_v1_9=b1_v1_10;
          b1_v1_7=v1_8*b1_v1_9; b1_v1_8=v1_7*b1_v1_9;
          b1_x[9]=b1_x[9]+b1_v1_8;
          b1_p[1]=b1_p[1]+b1_v1_7;
          b1_v1_0=b1_v1_6; b1_v1_5=0-b1_v1_6;
          b1_v1_3=v1_4*b1_v1_5; b1_v1_4=v1_3*b1_v1_5;
          b1_x[5]=b1_x[5]+b1_v1_4;
          b1_v1_1=v1_2*b1_v1_3; b1_v1_2=v1_1*b1_v1_3;
          b1_x[1]=b1_x[1]+b1_v1_2;
          b1_p[0]=b1_p[0]+b1_v1_1;
          // incomplete SAC
          fds_c=fds_c-1; f[0]=fds[fds_c];
          v1_0=0;
          v1_1=p[2];
          v1_2=x[1];
          v1_3=v1_1*v1_2;
          v1_4=x[7];
          v1_5=v1_3*v1_4;
          v1_6=v1_0-v1_5;
          // adjoint assignment
          b1_v1_6=b1_f[0]; b1_f[0]=0;
          b1_v1_0=b1_v1_6; b1_v1_5=0-b1_v1_6;
          b1_v1_3=v1_4*b1_v1_5; b1_v1_4=v1_3*b1_v1_5;
          b1_x[7]=b1_x[7]+b1_v1_4;
          b1_v1_1=v1_2*b1_v1_3; b1_v1_2=v1_1*b1_v1_3;
          b1_x[1]=b1_x[1]+b1_v1_2;
          b1_p[2]=b1_p[2]+b1_v1_1;
        }
      }
   }
   if (bmode_1==2) {
      bmode_1=bmode_1;
   }
   if (bmode_1==3) {
      bmode_1=bmode_1;
   }
}
